config: use chmod() instead of fchmod()
[git.git] / git-submodule.sh
blob4a30087768a16d77bfcec41889f58b64fdf5f89c
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 command=
26 branch=
27 force=
28 reference=
29 cached=
30 recursive=
31 init=
32 files=
33 remote=
34 nofetch=
35 update=
36 prefix=
37 custom_name=
38 depth=
40 # The function takes at most 2 arguments. The first argument is the
41 # URL that navigates to the submodule origin repo. When relative, this URL
42 # is relative to the superproject origin URL repo. The second up_path
43 # argument, if specified, is the relative path that navigates
44 # from the submodule working tree to the superproject working tree.
46 # The output of the function is the origin URL of the submodule.
48 # The output will either be an absolute URL or filesystem path (if the
49 # superproject origin URL is an absolute URL or filesystem path,
50 # respectively) or a relative file system path (if the superproject
51 # origin URL is a relative file system path).
53 # When the output is a relative file system path, the path is either
54 # relative to the submodule working tree, if up_path is specified, or to
55 # the superproject working tree otherwise.
56 resolve_relative_url ()
58 remote=$(get_default_remote)
59 remoteurl=$(git config "remote.$remote.url") ||
60 remoteurl=$(pwd) # the repository is its own authoritative upstream
61 url="$1"
62 remoteurl=${remoteurl%/}
63 sep=/
64 up_path="$2"
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
70 ./*|../*)
71 is_relative=t
74 is_relative=t
75 remoteurl="./$remoteurl"
77 esac
79 while test -n "$url"
81 case "$url" in
82 ../*)
83 url="${url#../}"
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
100 esac
102 ./*)
103 url="${url#./}"
106 break;;
107 esac
108 done
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
113 # Resolve a path to be relative to another path. This is intended for
114 # converting submodule paths when git-submodule is run in a subdirectory
115 # and only handles paths where the directory separator is '/'.
117 # The output is the first argument as a path relative to the second argument,
118 # which defaults to $wt_prefix if it is omitted.
119 relative_path ()
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
127 while test -n "$curdir"
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
134 esac
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
143 done
145 echo "$result$target"
149 # Get submodule info for registered submodules
150 # $@ = path to limit submodule list
152 module_list()
154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
156 git ls-files -z --error-unmatch --stage -- "$@" ||
157 echo "unmatched pathspec exists"
159 @@PERL@@ -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
162 my @out = ();
163 my $unmatched = 0;
164 $/ = "\0";
165 while (<STDIN>) {
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
176 push @out, "$mode $null_sha1 U\t$path\n";
178 next;
180 push @out, "$_\n";
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
190 die_if_unmatched ()
192 if test "$1" = "#unmatched"
193 then
194 exit 1
199 # Print a submodule configuration setting
201 # $1 = submodule name
202 # $2 = option name
203 # $3 = default value
205 # Checks in the usual git-config places first (for overrides),
206 # otherwise it falls back on .gitmodules. This allows you to
207 # distribute project-wide defaults in .gitmodules, while still
208 # customizing individual repositories if necessary. If the option is
209 # not in .gitmodules either, print a default value.
211 get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
220 printf '%s' "${value:-$default}"
225 # Map submodule path to submodule name
227 # $1 = path
229 module_name()
231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
232 sm_path="$1"
233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
236 test -z "$name" &&
237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
238 echo "$name"
242 # Clone a submodule
244 # Prior to calling, cmd_update checks that a possibly existing
245 # path is not a git repository.
246 # Likewise, cmd_add checks that path does not exist at all,
247 # since it is the location of a new submodule.
249 module_clone()
251 sm_path=$1
252 name=$2
253 url=$3
254 reference="$4"
255 depth="$5"
256 quiet=
257 if test -n "$GIT_QUIET"
258 then
259 quiet=-q
262 gitdir=
263 gitdir_base=
264 base_name=$(dirname "$name")
266 gitdir=$(git rev-parse --git-dir)
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
270 if test -d "$gitdir"
271 then
272 mkdir -p "$sm_path"
273 rm -f "$gitdir/index"
274 else
275 mkdir -p "$gitdir_base"
277 clear_local_git_env
278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
280 ) ||
281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
288 # normalize Windows-style absolute paths to POSIX-style absolute paths
289 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
290 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
291 # Remove all common leading directories after a sanity check
292 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
293 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
295 while test "${a%%/*}" = "${b%%/*}"
297 a=${a#*/}
298 b=${b#*/}
299 done
300 # Now chop off the trailing '/'s that were added in the beginning
301 a=${a%/}
302 b=${b%/}
304 # Turn each leading "*/" component into "../"
305 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
306 echo "gitdir: $rel/$a" >"$sm_path/.git"
308 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
309 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
312 isnumber()
314 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
318 # Add a new submodule to the working tree, .gitmodules and the index
320 # $@ = repo path
322 # optional branch is stored in global branch variable
324 cmd_add()
326 # parse $args after "submodule ... add".
327 reference_path=
328 while test $# -ne 0
330 case "$1" in
331 -b | --branch)
332 case "$2" in '') usage ;; esac
333 branch=$2
334 shift
336 -f | --force)
337 force=$1
339 -q|--quiet)
340 GIT_QUIET=1
342 --reference)
343 case "$2" in '') usage ;; esac
344 reference_path=$2
345 shift
347 --reference=*)
348 reference_path="${1#--reference=}"
350 --name)
351 case "$2" in '') usage ;; esac
352 custom_name=$2
353 shift
355 --depth)
356 case "$2" in '') usage ;; esac
357 depth="--depth=$2"
358 shift
360 --depth=*)
361 depth=$1
364 shift
365 break
368 usage
371 break
373 esac
374 shift
375 done
377 if test -n "$reference_path"
378 then
379 is_absolute_path "$reference_path" ||
380 reference_path="$wt_prefix$reference_path"
382 reference="--reference=$reference_path"
385 repo=$1
386 sm_path=$2
388 if test -z "$sm_path"; then
389 sm_path=$(echo "$repo" |
390 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
393 if test -z "$repo" -o -z "$sm_path"; then
394 usage
397 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
399 # assure repo is absolute or relative to parent
400 case "$repo" in
401 ./*|../*)
402 test -z "$wt_prefix" ||
403 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
405 # dereference source url relative to parent's url
406 realrepo=$(resolve_relative_url "$repo") || exit
408 *:*|/*)
409 # absolute url
410 realrepo=$repo
413 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
415 esac
417 # normalize path:
418 # multiple //; leading ./; /./; /../; trailing /
419 sm_path=$(printf '%s/\n' "$sm_path" |
420 sed -e '
421 s|//*|/|g
422 s|^\(\./\)*||
423 s|/\./|/|g
424 :start
425 s|\([^/]*\)/\.\./||
426 tstart
427 s|/*$||
429 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
430 die "$(eval_gettext "'\$sm_path' already exists in the index")"
432 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
433 then
434 eval_gettextln "The following path is ignored by one of your .gitignore files:
435 \$sm_path
436 Use -f if you really want to add it." >&2
437 exit 1
440 if test -n "$custom_name"
441 then
442 sm_name="$custom_name"
443 else
444 sm_name="$sm_path"
447 # perhaps the path exists and is already a git repo, else clone it
448 if test -e "$sm_path"
449 then
450 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
451 then
452 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
453 else
454 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
457 else
458 if test -d ".git/modules/$sm_name"
459 then
460 if test -z "$force"
461 then
462 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
463 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
464 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
465 echo >&2 " $realrepo"
466 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
467 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
468 else
469 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
472 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
474 clear_local_git_env
475 cd "$sm_path" &&
476 # ash fails to wordsplit ${branch:+-b "$branch"...}
477 case "$branch" in
478 '') git checkout -f -q ;;
479 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
480 esac
481 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
483 git config submodule."$sm_name".url "$realrepo"
485 git add $force "$sm_path" ||
486 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
488 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
489 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
490 if test -n "$branch"
491 then
492 git config -f .gitmodules submodule."$sm_name".branch "$branch"
493 fi &&
494 git add --force .gitmodules ||
495 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
499 # Execute an arbitrary command sequence in each checked out
500 # submodule
502 # $@ = command to execute
504 cmd_foreach()
506 # parse $args after "submodule ... foreach".
507 while test $# -ne 0
509 case "$1" in
510 -q|--quiet)
511 GIT_QUIET=1
513 --recursive)
514 recursive=1
517 usage
520 break
522 esac
523 shift
524 done
526 toplevel=$(pwd)
528 # dup stdin so that it can be restored when running the external
529 # command in the subshell (and a recursive call to this function)
530 exec 3<&0
532 module_list |
533 while read mode sha1 stage sm_path
535 die_if_unmatched "$mode"
536 if test -e "$sm_path"/.git
537 then
538 displaypath=$(relative_path "$sm_path")
539 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
540 name=$(module_name "$sm_path")
542 prefix="$prefix$sm_path/"
543 clear_local_git_env
544 cd "$sm_path" &&
545 sm_path=$(relative_path "$sm_path") &&
546 # we make $path available to scripts ...
547 path=$sm_path &&
548 if test $# -eq 1
549 then
550 eval "$1"
551 else
552 "$@"
553 fi &&
554 if test -n "$recursive"
555 then
556 cmd_foreach "--recursive" "$@"
558 ) <&3 3<&- ||
559 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
561 done
565 # Register submodules in .git/config
567 # $@ = requested paths (default to all)
569 cmd_init()
571 # parse $args after "submodule ... init".
572 while test $# -ne 0
574 case "$1" in
575 -q|--quiet)
576 GIT_QUIET=1
579 shift
580 break
583 usage
586 break
588 esac
589 shift
590 done
592 module_list "$@" |
593 while read mode sha1 stage sm_path
595 die_if_unmatched "$mode"
596 name=$(module_name "$sm_path") || exit
598 displaypath=$(relative_path "$sm_path")
600 # Copy url setting when it is not set yet
601 if test -z "$(git config "submodule.$name.url")"
602 then
603 url=$(git config -f .gitmodules submodule."$name".url)
604 test -z "$url" &&
605 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
607 # Possibly a url relative to parent
608 case "$url" in
609 ./*|../*)
610 url=$(resolve_relative_url "$url") || exit
612 esac
613 git config submodule."$name".url "$url" ||
614 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
616 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
619 # Copy "update" setting when it is not set yet
620 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
621 test -n "$upd" &&
622 test -z "$(git config submodule."$name".update)"
623 then
624 case "$upd" in
625 checkout | rebase | merge | none)
626 ;; # known modes of updating
628 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
629 upd=none
631 esac
632 git config submodule."$name".update "$upd" ||
633 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
635 done
639 # Unregister submodules from .git/config and remove their work tree
641 # $@ = requested paths (use '.' to deinit all submodules)
643 cmd_deinit()
645 # parse $args after "submodule ... deinit".
646 while test $# -ne 0
648 case "$1" in
649 -f|--force)
650 force=$1
652 -q|--quiet)
653 GIT_QUIET=1
656 shift
657 break
660 usage
663 break
665 esac
666 shift
667 done
669 if test $# = 0
670 then
671 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
674 module_list "$@" |
675 while read mode sha1 stage sm_path
677 die_if_unmatched "$mode"
678 name=$(module_name "$sm_path") || exit
680 displaypath=$(relative_path "$sm_path")
682 # Remove the submodule work tree (unless the user already did it)
683 if test -d "$sm_path"
684 then
685 # Protect submodules containing a .git directory
686 if test -d "$sm_path/.git"
687 then
688 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
689 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
692 if test -z "$force"
693 then
694 git rm -qn "$sm_path" ||
695 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
697 rm -rf "$sm_path" &&
698 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
699 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
702 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
704 # Remove the .git/config entries (unless the user already did it)
705 if test -n "$(git config --get-regexp submodule."$name\.")"
706 then
707 # Remove the whole section so we have a clean state when
708 # the user later decides to init this submodule again
709 url=$(git config submodule."$name".url)
710 git config --remove-section submodule."$name" 2>/dev/null &&
711 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
713 done
717 # Update each submodule path to correct revision, using clone and checkout as needed
719 # $@ = requested paths (default to all)
721 cmd_update()
723 # parse $args after "submodule ... update".
724 while test $# -ne 0
726 case "$1" in
727 -q|--quiet)
728 GIT_QUIET=1
730 -i|--init)
731 init=1
733 --remote)
734 remote=1
736 -N|--no-fetch)
737 nofetch=1
739 -f|--force)
740 force=$1
742 -r|--rebase)
743 update="rebase"
745 --reference)
746 case "$2" in '') usage ;; esac
747 reference="--reference=$2"
748 shift
750 --reference=*)
751 reference="$1"
753 -m|--merge)
754 update="merge"
756 --recursive)
757 recursive=1
759 --checkout)
760 update="checkout"
762 --depth)
763 case "$2" in '') usage ;; esac
764 depth="--depth=$2"
765 shift
767 --depth=*)
768 depth=$1
771 shift
772 break
775 usage
778 break
780 esac
781 shift
782 done
784 if test -n "$init"
785 then
786 cmd_init "--" "$@" || return
789 cloned_modules=
790 module_list "$@" | {
791 err=
792 while read mode sha1 stage sm_path
794 die_if_unmatched "$mode"
795 if test "$stage" = U
796 then
797 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
798 continue
800 name=$(module_name "$sm_path") || exit
801 url=$(git config submodule."$name".url)
802 branch=$(get_submodule_config "$name" branch master)
803 if ! test -z "$update"
804 then
805 update_module=$update
806 else
807 update_module=$(git config submodule."$name".update)
808 case "$update_module" in
810 ;; # Unset update mode
811 checkout | rebase | merge | none)
812 ;; # Known update modes
814 ;; # Custom update command
816 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
818 esac
821 displaypath=$(relative_path "$prefix$sm_path")
823 if test "$update_module" = "none"
824 then
825 echo "Skipping submodule '$displaypath'"
826 continue
829 if test -z "$url"
830 then
831 # Only mention uninitialized submodules when its
832 # path have been specified
833 test "$#" != "0" &&
834 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
835 Maybe you want to use 'update --init'?")"
836 continue
839 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
840 then
841 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
842 cloned_modules="$cloned_modules;$name"
843 subsha1=
844 else
845 subsha1=$(clear_local_git_env; cd "$sm_path" &&
846 git rev-parse --verify HEAD) ||
847 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
850 if test -n "$remote"
851 then
852 if test -z "$nofetch"
853 then
854 # Fetch remote before determining tracking $sha1
855 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
856 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
858 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
859 sha1=$(clear_local_git_env; cd "$sm_path" &&
860 git rev-parse --verify "${remote_name}/${branch}") ||
861 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
864 if test "$subsha1" != "$sha1" -o -n "$force"
865 then
866 subforce=$force
867 # If we don't already have a -f flag and the submodule has never been checked out
868 if test -z "$subsha1" -a -z "$force"
869 then
870 subforce="-f"
873 if test -z "$nofetch"
874 then
875 # Run fetch only if $sha1 isn't present or it
876 # is not reachable from a ref.
877 (clear_local_git_env; cd "$sm_path" &&
878 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
879 test -z "$rev") || git-fetch)) ||
880 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
883 # Is this something we just cloned?
884 case ";$cloned_modules;" in
885 *";$name;"*)
886 # then there is no local change to integrate
887 update_module= ;;
888 esac
890 must_die_on_failure=
891 case "$update_module" in
892 rebase)
893 command="git rebase"
894 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
895 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
896 must_die_on_failure=yes
898 merge)
899 command="git merge"
900 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
901 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
902 must_die_on_failure=yes
905 command="${update_module#!}"
906 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
907 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
908 must_die_on_failure=yes
911 command="git checkout $subforce -q"
912 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
913 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
915 esac
917 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
918 then
919 say "$say_msg"
920 elif test -n "$must_die_on_failure"
921 then
922 die_with_status 2 "$die_msg"
923 else
924 err="${err};$die_msg"
925 continue
929 if test -n "$recursive"
930 then
932 prefix="$prefix$sm_path/"
933 clear_local_git_env
934 cd "$sm_path" &&
935 eval cmd_update
937 res=$?
938 if test $res -gt 0
939 then
940 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
941 if test $res -eq 1
942 then
943 err="${err};$die_msg"
944 continue
945 else
946 die_with_status $res "$die_msg"
950 done
952 if test -n "$err"
953 then
954 OIFS=$IFS
955 IFS=';'
956 for e in $err
958 if test -n "$e"
959 then
960 echo >&2 "$e"
962 done
963 IFS=$OIFS
964 exit 1
969 set_name_rev () {
970 revname=$( (
971 clear_local_git_env
972 cd "$1" && {
973 git describe "$2" 2>/dev/null ||
974 git describe --tags "$2" 2>/dev/null ||
975 git describe --contains "$2" 2>/dev/null ||
976 git describe --all --always "$2"
979 test -z "$revname" || revname=" ($revname)"
982 # Show commit summary for submodules in index or working tree
984 # If '--cached' is given, show summary between index and given commit,
985 # or between working tree and given commit
987 # $@ = [commit (default 'HEAD'),] requested paths (default all)
989 cmd_summary() {
990 summary_limit=-1
991 for_status=
992 diff_cmd=diff-index
994 # parse $args after "submodule ... summary".
995 while test $# -ne 0
997 case "$1" in
998 --cached)
999 cached="$1"
1001 --files)
1002 files="$1"
1004 --for-status)
1005 for_status="$1"
1007 -n|--summary-limit)
1008 summary_limit="$2"
1009 isnumber "$summary_limit" || usage
1010 shift
1012 --summary-limit=*)
1013 summary_limit="${1#--summary-limit=}"
1014 isnumber "$summary_limit" || usage
1017 shift
1018 break
1021 usage
1024 break
1026 esac
1027 shift
1028 done
1030 test $summary_limit = 0 && return
1032 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1033 then
1034 head=$rev
1035 test $# = 0 || shift
1036 elif test -z "$1" -o "$1" = "HEAD"
1037 then
1038 # before the first commit: compare with an empty tree
1039 head=$(git hash-object -w -t tree --stdin </dev/null)
1040 test -z "$1" || shift
1041 else
1042 head="HEAD"
1045 if [ -n "$files" ]
1046 then
1047 test -n "$cached" &&
1048 die "$(gettext "The --cached option cannot be used with the --files option")"
1049 diff_cmd=diff-files
1050 head=
1053 cd_to_toplevel
1054 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1055 # Get modified modules cared by user
1056 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1057 sane_egrep '^:([0-7]* )?160000' |
1058 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1060 # Always show modules deleted or type-changed (blob<->module)
1061 test $status = D -o $status = T && echo "$sm_path" && continue
1062 # Respect the ignore setting for --for-status.
1063 if test -n "$for_status"
1064 then
1065 name=$(module_name "$sm_path")
1066 ignore_config=$(get_submodule_config "$name" ignore none)
1067 test $status != A -a $ignore_config = all && continue
1069 # Also show added or modified modules which are checked out
1070 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1071 echo "$sm_path"
1072 done
1075 test -z "$modules" && return
1077 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1078 sane_egrep '^:([0-7]* )?160000' |
1079 cut -c2- |
1080 while read mod_src mod_dst sha1_src sha1_dst status name
1082 if test -z "$cached" &&
1083 test $sha1_dst = 0000000000000000000000000000000000000000
1084 then
1085 case "$mod_dst" in
1086 160000)
1087 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1089 100644 | 100755 | 120000)
1090 sha1_dst=$(git hash-object $name)
1092 000000)
1093 ;; # removed
1095 # unexpected type
1096 eval_gettextln "unexpected mode \$mod_dst" >&2
1097 continue ;;
1098 esac
1100 missing_src=
1101 missing_dst=
1103 test $mod_src = 160000 &&
1104 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1105 missing_src=t
1107 test $mod_dst = 160000 &&
1108 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1109 missing_dst=t
1111 display_name=$(relative_path "$name")
1113 total_commits=
1114 case "$missing_src,$missing_dst" in
1116 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1119 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1121 t,t)
1122 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1125 errmsg=
1126 total_commits=$(
1127 if test $mod_src = 160000 -a $mod_dst = 160000
1128 then
1129 range="$sha1_src...$sha1_dst"
1130 elif test $mod_src = 160000
1131 then
1132 range=$sha1_src
1133 else
1134 range=$sha1_dst
1136 GIT_DIR="$name/.git" \
1137 git rev-list --first-parent $range -- | wc -l
1139 total_commits=" ($(($total_commits + 0)))"
1141 esac
1143 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1144 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1145 if test $status = T
1146 then
1147 blob="$(gettext "blob")"
1148 submodule="$(gettext "submodule")"
1149 if test $mod_dst = 160000
1150 then
1151 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1152 else
1153 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1155 else
1156 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1158 if test -n "$errmsg"
1159 then
1160 # Don't give error msg for modification whose dst is not submodule
1161 # i.e. deleted or changed to blob
1162 test $mod_dst = 160000 && echo "$errmsg"
1163 else
1164 if test $mod_src = 160000 -a $mod_dst = 160000
1165 then
1166 limit=
1167 test $summary_limit -gt 0 && limit="-$summary_limit"
1168 GIT_DIR="$name/.git" \
1169 git log $limit --pretty='format: %m %s' \
1170 --first-parent $sha1_src...$sha1_dst
1171 elif test $mod_dst = 160000
1172 then
1173 GIT_DIR="$name/.git" \
1174 git log --pretty='format: > %s' -1 $sha1_dst
1175 else
1176 GIT_DIR="$name/.git" \
1177 git log --pretty='format: < %s' -1 $sha1_src
1179 echo
1181 echo
1182 done
1185 # List all submodules, prefixed with:
1186 # - submodule not initialized
1187 # + different revision checked out
1189 # If --cached was specified the revision in the index will be printed
1190 # instead of the currently checked out revision.
1192 # $@ = requested paths (default to all)
1194 cmd_status()
1196 # parse $args after "submodule ... status".
1197 while test $# -ne 0
1199 case "$1" in
1200 -q|--quiet)
1201 GIT_QUIET=1
1203 --cached)
1204 cached=1
1206 --recursive)
1207 recursive=1
1210 shift
1211 break
1214 usage
1217 break
1219 esac
1220 shift
1221 done
1223 module_list "$@" |
1224 while read mode sha1 stage sm_path
1226 die_if_unmatched "$mode"
1227 name=$(module_name "$sm_path") || exit
1228 url=$(git config submodule."$name".url)
1229 displaypath=$(relative_path "$prefix$sm_path")
1230 if test "$stage" = U
1231 then
1232 say "U$sha1 $displaypath"
1233 continue
1235 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1236 then
1237 say "-$sha1 $displaypath"
1238 continue;
1240 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1241 then
1242 set_name_rev "$sm_path" "$sha1"
1243 say " $sha1 $displaypath$revname"
1244 else
1245 if test -z "$cached"
1246 then
1247 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1249 set_name_rev "$sm_path" "$sha1"
1250 say "+$sha1 $displaypath$revname"
1253 if test -n "$recursive"
1254 then
1256 prefix="$displaypath/"
1257 clear_local_git_env
1258 cd "$sm_path" &&
1259 eval cmd_status
1260 ) ||
1261 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1263 done
1266 # Sync remote urls for submodules
1267 # This makes the value for remote.$remote.url match the value
1268 # specified in .gitmodules.
1270 cmd_sync()
1272 while test $# -ne 0
1274 case "$1" in
1275 -q|--quiet)
1276 GIT_QUIET=1
1277 shift
1279 --recursive)
1280 recursive=1
1281 shift
1284 shift
1285 break
1288 usage
1291 break
1293 esac
1294 done
1295 cd_to_toplevel
1296 module_list "$@" |
1297 while read mode sha1 stage sm_path
1299 die_if_unmatched "$mode"
1300 name=$(module_name "$sm_path")
1301 url=$(git config -f .gitmodules --get submodule."$name".url)
1303 # Possibly a url relative to parent
1304 case "$url" in
1305 ./*|../*)
1306 # rewrite foo/bar as ../.. to find path from
1307 # submodule work tree to superproject work tree
1308 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1309 # guarantee a trailing /
1310 up_path=${up_path%/}/ &&
1311 # path from submodule work tree to submodule origin repo
1312 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1313 # path from superproject work tree to submodule origin repo
1314 super_config_url=$(resolve_relative_url "$url") || exit
1317 sub_origin_url="$url"
1318 super_config_url="$url"
1320 esac
1322 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1323 then
1324 displaypath=$(relative_path "$prefix$sm_path")
1325 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1326 git config submodule."$name".url "$super_config_url"
1328 if test -e "$sm_path"/.git
1329 then
1331 clear_local_git_env
1332 cd "$sm_path"
1333 remote=$(get_default_remote)
1334 git config remote."$remote".url "$sub_origin_url"
1336 if test -n "$recursive"
1337 then
1338 prefix="$prefix$sm_path/"
1339 eval cmd_sync
1344 done
1347 # This loop parses the command line arguments to find the
1348 # subcommand name to dispatch. Parsing of the subcommand specific
1349 # options are primarily done by the subcommand implementations.
1350 # Subcommand specific options such as --branch and --cached are
1351 # parsed here as well, for backward compatibility.
1353 while test $# != 0 && test -z "$command"
1355 case "$1" in
1356 add | foreach | init | deinit | update | status | summary | sync)
1357 command=$1
1359 -q|--quiet)
1360 GIT_QUIET=1
1362 -b|--branch)
1363 case "$2" in
1365 usage
1367 esac
1368 branch="$2"; shift
1370 --cached)
1371 cached="$1"
1374 break
1377 usage
1380 break
1382 esac
1383 shift
1384 done
1386 # No command word defaults to "status"
1387 if test -z "$command"
1388 then
1389 if test $# = 0
1390 then
1391 command=status
1392 else
1393 usage
1397 # "-b branch" is accepted only by "add"
1398 if test -n "$branch" && test "$command" != add
1399 then
1400 usage
1403 # "--cached" is accepted only by "status" and "summary"
1404 if test -n "$cached" && test "$command" != status -a "$command" != summary
1405 then
1406 usage
1409 "cmd_$command" "$@"